<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <meta name="google-signin-client_id" content="{{ GOOGLE_AUTH_CLIENT_ID }}">
    <title>Google sign in</title>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/axios/0.25.0/axios.min.js" integrity="sha512-/Q6t3CASm04EliI1QyIDAA/nDo9R8FQ/BULoUFyN4n/BDdyIxeH7u++Z+eobdmr11gG5D/6nPFyDlnisDwhpYA==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>

</head>
<body>

<div>Open console and use button below</div>

<div class="g-signin2" data-onsuccess="onSignIn"></div>

<div>Information:</div>
<div style="max-width: 600px">
    <pre id="info" style="white-space: pre-wrap; overflow-wrap: break-word;"></pre>
</div>

<script>

    async function renderInfo(googleUser, authInfo, selector) {
        const profile = googleUser.getBasicProfile();

        const element = document.querySelector(selector);

        const content = {
            name: profile.getName(),
            email: profile.getEmail(),
            accessToken: authInfo.accessToken,
            refreshToken: authInfo.refreshToken,
            expiresIn: authInfo.expiresIn,
            type: authInfo.type
        }

        element.innerHTML = JSON.stringify(content, null, 2);
    }

    async function onSignIn(googleUser) {
        const profile = googleUser.getBasicProfile();
        console.log('ID: ' + profile.getId()); // Do not send to your backend! Use an ID token instead.
        console.log('Name: ' + profile.getName());
        console.log('Image URL: ' + profile.getImageUrl());
        console.log('Email: ' + profile.getEmail()); // This is null if the 'email' scope is not present.

        const id_token = googleUser.getAuthResponse().id_token
        const response = await axios.post('/api/v1/auth/google-sign-in', {
            idToken: id_token
        });

        console.log('Axios response', response);

        await renderInfo(googleUser, response.data, '#info')
    }
</script>

<script src="https://apis.google.com/js/platform.js" async defer></script>
</body>
</html>
